diff --git a/src/backend/postmaster/autovacuum.c b/src/backend/postmaster/autovacuum.c
new file mode 100644
index 89dd3b3..0bd6ce1
*** a/src/backend/postmaster/autovacuum.c
--- b/src/backend/postmaster/autovacuum.c
*************** int			autovacuum_vac_thresh;
*** 117,124 ****
  double		autovacuum_vac_scale;
  int			autovacuum_anl_thresh;
  double		autovacuum_anl_scale;
! int			autovacuum_freeze_max_age;
! int			autovacuum_multixact_freeze_max_age;
  
  int			autovacuum_vac_cost_delay;
  int			autovacuum_vac_cost_limit;
--- 117,124 ----
  double		autovacuum_vac_scale;
  int			autovacuum_anl_thresh;
  double		autovacuum_anl_scale;
! int64		autovacuum_freeze_max_age;
! int64		autovacuum_multixact_freeze_max_age;
  
  int			autovacuum_vac_cost_delay;
  int			autovacuum_vac_cost_limit;
*************** static TransactionId recentXid;
*** 146,155 ****
  static MultiXactId recentMulti;
  
  /* Default freeze ages to use for autovacuum (varies by database) */
! static int	default_freeze_min_age;
! static int	default_freeze_table_age;
! static int	default_multixact_freeze_min_age;
! static int	default_multixact_freeze_table_age;
  
  /* Memory context for long-lived data */
  static MemoryContext AutovacMemCxt;
--- 146,155 ----
  static MultiXactId recentMulti;
  
  /* Default freeze ages to use for autovacuum (varies by database) */
! static int64	default_freeze_min_age;
! static int64	default_freeze_table_age;
! static int64	default_multixact_freeze_min_age;
! static int64	default_multixact_freeze_table_age;
  
  /* Memory context for long-lived data */
  static MemoryContext AutovacMemCxt;
*************** static void FreeWorkerInfo(int code, Dat
*** 333,343 ****
  
  static autovac_table *table_recheck_autovac(Oid relid, HTAB *table_toast_map,
  					  TupleDesc pg_class_desc,
! 					  int effective_multixact_freeze_max_age);
  static void relation_needs_vacanalyze(Oid relid, AutoVacOpts *relopts,
  						  Form_pg_class classForm,
  						  PgStat_StatTabEntry *tabentry,
! 						  int effective_multixact_freeze_max_age,
  						  bool *dovacuum, bool *doanalyze, bool *wraparound);
  
  static void autovacuum_do_vac_analyze(autovac_table *tab,
--- 333,343 ----
  
  static autovac_table *table_recheck_autovac(Oid relid, HTAB *table_toast_map,
  					  TupleDesc pg_class_desc,
! 					  int64 effective_multixact_freeze_max_age);
  static void relation_needs_vacanalyze(Oid relid, AutoVacOpts *relopts,
  						  Form_pg_class classForm,
  						  PgStat_StatTabEntry *tabentry,
! 						  int64 effective_multixact_freeze_max_age,
  						  bool *dovacuum, bool *doanalyze, bool *wraparound);
  
  static void autovacuum_do_vac_analyze(autovac_table *tab,
*************** do_start_worker(void)
*** 1140,1145 ****
--- 1140,1146 ----
  	ListCell   *cell;
  	TransactionId xidForceLimit;
  	MultiXactId multiForceLimit;
+ 	int64		multiMembersThreshold;
  	bool		for_xid_wrap;
  	bool		for_multi_wrap;
  	avw_dbase  *avdb;
*************** do_start_worker(void)
*** 1179,1195 ****
  	 * particular tables, but not loosened.)
  	 */
  	recentXid = ReadNewTransactionId();
! 	xidForceLimit = recentXid - autovacuum_freeze_max_age;
! 	/* ensure it's a "normal" XID, else TransactionIdPrecedes misbehaves */
! 	/* this can cause the limit to go backwards by 3, but that's OK */
! 	if (xidForceLimit < FirstNormalTransactionId)
! 		xidForceLimit -= FirstNormalTransactionId;
  
  	/* Also determine the oldest datminmxid we will consider. */
  	recentMulti = ReadNextMultiXactId();
! 	multiForceLimit = recentMulti - MultiXactMemberFreezeThreshold();
! 	if (multiForceLimit < FirstMultiXactId)
! 		multiForceLimit -= FirstMultiXactId;
  
  	/*
  	 * Choose a database to connect to.  We pick the database that was least
--- 1180,1197 ----
  	 * particular tables, but not loosened.)
  	 */
  	recentXid = ReadNewTransactionId();
! 	if (recentXid > FirstNormalTransactionId + autovacuum_freeze_max_age)
! 		xidForceLimit = recentXid - autovacuum_freeze_max_age;
! 	else
! 		xidForceLimit = FirstNormalTransactionId;
  
  	/* Also determine the oldest datminmxid we will consider. */
  	recentMulti = ReadNextMultiXactId();
! 	multiMembersThreshold = autovacuum_multixact_freeze_max_age;
! 	if (recentMulti > FirstMultiXactId + multiMembersThreshold)
! 		multiForceLimit = recentMulti - multiMembersThreshold;
! 	else
! 		multiForceLimit = FirstMultiXactId;
  
  	/*
  	 * Choose a database to connect to.  We pick the database that was least
*************** do_autovacuum(void)
*** 1962,1968 ****
  	BufferAccessStrategy bstrategy;
  	ScanKeyData key;
  	TupleDesc	pg_class_desc;
! 	int			effective_multixact_freeze_max_age;
  	bool		did_vacuum = false;
  	bool		found_concurrent_worker = false;
  
--- 1964,1970 ----
  	BufferAccessStrategy bstrategy;
  	ScanKeyData key;
  	TupleDesc	pg_class_desc;
! 	int64		effective_multixact_freeze_max_age;
  	bool		did_vacuum = false;
  	bool		found_concurrent_worker = false;
  
*************** do_autovacuum(void)
*** 1997,2003 ****
  	 * normally autovacuum_multixact_freeze_max_age, but may be less if we are
  	 * short of multixact member space.
  	 */
! 	effective_multixact_freeze_max_age = MultiXactMemberFreezeThreshold();
  
  	/*
  	 * Find the pg_database entry and select the default freeze ages. We use
--- 1999,2005 ----
  	 * normally autovacuum_multixact_freeze_max_age, but may be less if we are
  	 * short of multixact member space.
  	 */
! 	effective_multixact_freeze_max_age = autovacuum_multixact_freeze_max_age;
  
  	/*
  	 * Find the pg_database entry and select the default freeze ages. We use
*************** get_pgstat_tabentry_relid(Oid relid, boo
*** 2786,2792 ****
  static autovac_table *
  table_recheck_autovac(Oid relid, HTAB *table_toast_map,
  					  TupleDesc pg_class_desc,
! 					  int effective_multixact_freeze_max_age)
  {
  	Form_pg_class classForm;
  	HeapTuple	classTup;
--- 2788,2794 ----
  static autovac_table *
  table_recheck_autovac(Oid relid, HTAB *table_toast_map,
  					  TupleDesc pg_class_desc,
! 					  int64 effective_multixact_freeze_max_age)
  {
  	Form_pg_class classForm;
  	HeapTuple	classTup;
*************** table_recheck_autovac(Oid relid, HTAB *t
*** 2842,2851 ****
  	/* OK, it needs something done */
  	if (doanalyze || dovacuum)
  	{
! 		int			freeze_min_age;
! 		int			freeze_table_age;
! 		int			multixact_freeze_min_age;
! 		int			multixact_freeze_table_age;
  		int			vac_cost_limit;
  		int			vac_cost_delay;
  		int			log_min_duration;
--- 2844,2853 ----
  	/* OK, it needs something done */
  	if (doanalyze || dovacuum)
  	{
! 		int64		freeze_min_age;
! 		int64		freeze_table_age;
! 		int64		multixact_freeze_min_age;
! 		int64		multixact_freeze_table_age;
  		int			vac_cost_limit;
  		int			vac_cost_delay;
  		int			log_min_duration;
*************** relation_needs_vacanalyze(Oid relid,
*** 2970,2976 ****
  						  AutoVacOpts *relopts,
  						  Form_pg_class classForm,
  						  PgStat_StatTabEntry *tabentry,
! 						  int effective_multixact_freeze_max_age,
   /* output params below */
  						  bool *dovacuum,
  						  bool *doanalyze,
--- 2972,2978 ----
  						  AutoVacOpts *relopts,
  						  Form_pg_class classForm,
  						  PgStat_StatTabEntry *tabentry,
! 						  int64 effective_multixact_freeze_max_age,
   /* output params below */
  						  bool *dovacuum,
  						  bool *doanalyze,
*************** relation_needs_vacanalyze(Oid relid,
*** 2995,3002 ****
  				anltuples;
  
  	/* freeze parameters */
! 	int			freeze_max_age;
! 	int			multixact_freeze_max_age;
  	TransactionId xidForceLimit;
  	MultiXactId multiForceLimit;
  
--- 2997,3004 ----
  				anltuples;
  
  	/* freeze parameters */
! 	int64		freeze_max_age;
! 	int64		multixact_freeze_max_age;
  	TransactionId xidForceLimit;
  	MultiXactId multiForceLimit;
  
*************** relation_needs_vacanalyze(Oid relid,
*** 3037,3053 ****
  	av_enabled = (relopts ? relopts->enabled : true);
  
  	/* Force vacuum if table is at risk of wraparound */
! 	xidForceLimit = recentXid - freeze_max_age;
! 	if (xidForceLimit < FirstNormalTransactionId)
! 		xidForceLimit -= FirstNormalTransactionId;
  	force_vacuum = (TransactionIdIsNormal(classForm->relfrozenxid) &&
  					TransactionIdPrecedes(classForm->relfrozenxid,
  										  xidForceLimit));
  	if (!force_vacuum)
  	{
! 		multiForceLimit = recentMulti - multixact_freeze_max_age;
! 		if (multiForceLimit < FirstMultiXactId)
! 			multiForceLimit -= FirstMultiXactId;
  		force_vacuum = MultiXactIdPrecedes(classForm->relminmxid,
  										   multiForceLimit);
  	}
--- 3039,3057 ----
  	av_enabled = (relopts ? relopts->enabled : true);
  
  	/* Force vacuum if table is at risk of wraparound */
! 	if (recentXid > FirstNormalTransactionId + freeze_max_age)
! 		xidForceLimit = recentXid - freeze_max_age;
! 	else
! 		xidForceLimit = FirstNormalTransactionId;
  	force_vacuum = (TransactionIdIsNormal(classForm->relfrozenxid) &&
  					TransactionIdPrecedes(classForm->relfrozenxid,
  										  xidForceLimit));
  	if (!force_vacuum)
  	{
! 		if (recentMulti > FirstMultiXactId + multixact_freeze_max_age)
! 			multiForceLimit = recentMulti - multixact_freeze_max_age;
! 		else
! 			multiForceLimit = FirstMultiXactId;
  		force_vacuum = MultiXactIdPrecedes(classForm->relminmxid,
  										   multiForceLimit);
  	}
diff --git a/src/backend/replication/logical/decode.c b/src/backend/replication/logical/decode.c
new file mode 100644
index 68825ef..b022617
*** a/src/backend/replication/logical/decode.c
--- b/src/backend/replication/logical/decode.c
*************** DecodeHeapOp(LogicalDecodingContext *ctx
*** 467,472 ****
--- 467,476 ----
  			/* we don't care about row level locks for now */
  			break;
  
+ 		case XLOG_HEAP_BASE_SHIFT:
+ 			/* we don't care about base shift */
+ 			break;
+ 
  		default:
  			elog(ERROR, "unexpected RM_HEAP_ID record type: %u", info);
  			break;
*************** DecodeInsert(LogicalDecodingContext *ctx
*** 643,650 ****
  	xl_heap_insert *xlrec;
  	ReorderBufferChange *change;
  	RelFileNode target_node;
  
! 	xlrec = (xl_heap_insert *) XLogRecGetData(r);
  
  	/* only interested in our database */
  	XLogRecGetBlockTag(r, 0, &target_node, NULL, NULL);
--- 647,659 ----
  	xl_heap_insert *xlrec;
  	ReorderBufferChange *change;
  	RelFileNode target_node;
+ 	bool		isinit = (XLogRecGetInfo(r) & XLOG_HEAP_INIT_PAGE) != 0;
+ 	Pointer		rec_data;
  
! 	rec_data = (Pointer) XLogRecGetData(r);
! 	if (isinit)
! 		rec_data += sizeof(TransactionId);
! 	xlrec = (xl_heap_insert *) rec_data;
  
  	/* only interested in our database */
  	XLogRecGetBlockTag(r, 0, &target_node, NULL, NULL);
*************** DecodeUpdate(LogicalDecodingContext *ctx
*** 695,702 ****
  	ReorderBufferChange *change;
  	char	   *data;
  	RelFileNode target_node;
  
! 	xlrec = (xl_heap_update *) XLogRecGetData(r);
  
  	/* only interested in our database */
  	XLogRecGetBlockTag(r, 0, &target_node, NULL, NULL);
--- 704,716 ----
  	ReorderBufferChange *change;
  	char	   *data;
  	RelFileNode target_node;
+ 	bool		isinit = (XLogRecGetInfo(r) & XLOG_HEAP_INIT_PAGE) != 0;
+ 	Pointer		rec_data;
  
! 	rec_data = (Pointer) XLogRecGetData(r);
! 	if (isinit)
! 		rec_data += sizeof(TransactionId);
! 	xlrec = (xl_heap_update *) rec_data;
  
  	/* only interested in our database */
  	XLogRecGetBlockTag(r, 0, &target_node, NULL, NULL);
*************** DecodeMultiInsert(LogicalDecodingContext
*** 820,827 ****
  	char	   *tupledata;
  	Size		tuplelen;
  	RelFileNode rnode;
  
! 	xlrec = (xl_heap_multi_insert *) XLogRecGetData(r);
  
  	/* only interested in our database */
  	XLogRecGetBlockTag(r, 0, &rnode, NULL, NULL);
--- 834,846 ----
  	char	   *tupledata;
  	Size		tuplelen;
  	RelFileNode rnode;
+ 	bool		isinit = (XLogRecGetInfo(r) & XLOG_HEAP_INIT_PAGE) != 0;
+ 	Pointer		rec_data;
  
! 	rec_data = (Pointer) XLogRecGetData(r);
! 	if (isinit)
! 		rec_data += sizeof(TransactionId);
! 	xlrec = (xl_heap_multi_insert *) rec_data;
  
  	/* only interested in our database */
  	XLogRecGetBlockTag(r, 0, &rnode, NULL, NULL);
*************** DecodeMultiInsert(LogicalDecodingContext
*** 877,882 ****
--- 896,902 ----
  			 * transactions.
  			 */
  			tuple->tuple.t_tableOid = InvalidOid;
+ 			HeapTupleSetZeroBase(&(tuple->tuple));
  
  			tuple->tuple.t_len = datalen + SizeofHeapTupleHeader;
  
*************** DecodeXLogTuple(char *data, Size len, Re
*** 967,972 ****
--- 987,993 ----
  
  	/* we can only figure this out after reassembling the transactions */
  	tuple->tuple.t_tableOid = InvalidOid;
+ 	HeapTupleSetZeroBase(&(tuple->tuple));
  
  	/* data is not stored aligned, copy to aligned storage */
  	memcpy((char *) &xlhdr,
diff --git a/src/backend/replication/logical/reorderbuffer.c b/src/backend/replication/logical/reorderbuffer.c
new file mode 100644
index 8f4f7f8..6cf745d
*** a/src/backend/replication/logical/reorderbuffer.c
--- b/src/backend/replication/logical/reorderbuffer.c
*************** ReorderBufferCommit(ReorderBuffer *rb, T
*** 1610,1616 ****
  
  		/* this is just a sanity check against bad output plugin behaviour */
  		if (GetCurrentTransactionIdIfAny() != InvalidTransactionId)
! 			elog(ERROR, "output plugin used XID %u",
  				 GetCurrentTransactionId());
  
  		/* cleanup */
--- 1610,1616 ----
  
  		/* this is just a sanity check against bad output plugin behaviour */
  		if (GetCurrentTransactionIdIfAny() != InvalidTransactionId)
! 			elog(ERROR, "output plugin used XID " XID_FMT,
  				 GetCurrentTransactionId());
  
  		/* cleanup */
*************** ReorderBufferAbortOld(ReorderBuffer *rb,
*** 1725,1731 ****
  
  		if (TransactionIdPrecedes(txn->xid, oldestRunningXid))
  		{
! 			elog(DEBUG2, "aborting old transaction %u", txn->xid);
  
  			/* remove potential on-disk data, and deallocate this tx */
  			ReorderBufferCleanupTXN(rb, txn);
--- 1725,1731 ----
  
  		if (TransactionIdPrecedes(txn->xid, oldestRunningXid))
  		{
! 			elog(DEBUG2, "aborting old transaction " XID_FMT, txn->xid);
  
  			/* remove potential on-disk data, and deallocate this tx */
  			ReorderBufferCleanupTXN(rb, txn);
*************** ReorderBufferSerializeTXN(ReorderBuffer 
*** 2061,2067 ****
  	Size		spilled = 0;
  	char		path[MAXPGPATH];
  
! 	elog(DEBUG2, "spill %u changes in XID %u to disk",
  		 (uint32) txn->nentries_mem, txn->xid);
  
  	/* do the same to all child TXs */
--- 2061,2067 ----
  	Size		spilled = 0;
  	char		path[MAXPGPATH];
  
! 	elog(DEBUG2, "spill %u changes in XID " XID_FMT " to disk",
  		 (uint32) txn->nentries_mem, txn->xid);
  
  	/* do the same to all child TXs */
*************** ReorderBufferSerializeTXN(ReorderBuffer 
*** 2098,2104 ****
  			 * No need to care about TLIs here, only used during a single run,
  			 * so each LSN only maps to a specific WAL record.
  			 */
! 			sprintf(path, "pg_replslot/%s/xid-%u-lsn-%X-%X.snap",
  					NameStr(MyReplicationSlot->data.name), txn->xid,
  					(uint32) (recptr >> 32), (uint32) recptr);
  
--- 2098,2104 ----
  			 * No need to care about TLIs here, only used during a single run,
  			 * so each LSN only maps to a specific WAL record.
  			 */
! 			sprintf(path, "pg_replslot/%s/xid-" XID_FMT "-lsn-%X-%X.snap",
  					NameStr(MyReplicationSlot->data.name), txn->xid,
  					(uint32) (recptr >> 32), (uint32) recptr);
  
*************** ReorderBufferSerializeChange(ReorderBuff
*** 2286,2292 ****
  		errno = save_errno;
  		ereport(ERROR,
  				(errcode_for_file_access(),
! 				 errmsg("could not write to data file for XID %u: %m",
  						txn->xid)));
  	}
  	pgstat_report_wait_end();
--- 2286,2292 ----
  		errno = save_errno;
  		ereport(ERROR,
  				(errcode_for_file_access(),
! 				 errmsg("could not write to data file for XID " XID_FMT ": %m",
  						txn->xid)));
  	}
  	pgstat_report_wait_end();
*************** ReorderBufferRestoreChanges(ReorderBuffe
*** 2345,2351 ****
  			 * No need to care about TLIs here, only used during a single run,
  			 * so each LSN only maps to a specific WAL record.
  			 */
! 			sprintf(path, "pg_replslot/%s/xid-%u-lsn-%X-%X.snap",
  					NameStr(MyReplicationSlot->data.name), txn->xid,
  					(uint32) (recptr >> 32), (uint32) recptr);
  
--- 2345,2351 ----
  			 * No need to care about TLIs here, only used during a single run,
  			 * so each LSN only maps to a specific WAL record.
  			 */
! 			sprintf(path, "pg_replslot/%s/xid-" XID_FMT "-lsn-%X-%X.snap",
  					NameStr(MyReplicationSlot->data.name), txn->xid,
  					(uint32) (recptr >> 32), (uint32) recptr);
  
*************** ReorderBufferRestoreCleanup(ReorderBuffe
*** 2587,2593 ****
  
  		XLogSegNoOffsetToRecPtr(cur, 0, recptr);
  
! 		sprintf(path, "pg_replslot/%s/xid-%u-lsn-%X-%X.snap",
  				NameStr(MyReplicationSlot->data.name), txn->xid,
  				(uint32) (recptr >> 32), (uint32) recptr);
  		if (unlink(path) != 0 && errno != ENOENT)
--- 2587,2593 ----
  
  		XLogSegNoOffsetToRecPtr(cur, 0, recptr);
  
! 		sprintf(path, "pg_replslot/%s/xid-" XID_FMT "-lsn-%X-%X.snap",
  				NameStr(MyReplicationSlot->data.name), txn->xid,
  				(uint32) (recptr >> 32), (uint32) recptr);
  		if (unlink(path) != 0 && errno != ENOENT)
*************** UpdateLogicalMappings(HTAB *tuplecid_dat
*** 3168,3175 ****
  		TransactionId f_mapped_xid;
  		TransactionId f_create_xid;
  		XLogRecPtr	f_lsn;
! 		uint32		f_hi,
! 					f_lo;
  		RewriteMappingFile *f;
  
  		if (strcmp(mapping_de->d_name, ".") == 0 ||
--- 3168,3179 ----
  		TransactionId f_mapped_xid;
  		TransactionId f_create_xid;
  		XLogRecPtr	f_lsn;
! 		uint32		f_lsn_hi,
! 					f_lsn_lo,
! 					f_mapped_xid_hi,
! 					f_mapped_xid_lo,
! 					f_create_xid_hi,
! 					f_create_xid_lo;
  		RewriteMappingFile *f;
  
  		if (strcmp(mapping_de->d_name, ".") == 0 ||
*************** UpdateLogicalMappings(HTAB *tuplecid_dat
*** 3181,3191 ****
  			continue;
  
  		if (sscanf(mapping_de->d_name, LOGICAL_REWRITE_FORMAT,
! 				   &f_dboid, &f_relid, &f_hi, &f_lo,
! 				   &f_mapped_xid, &f_create_xid) != 6)
  			elog(ERROR, "could not parse filename \"%s\"", mapping_de->d_name);
  
! 		f_lsn = ((uint64) f_hi) << 32 | f_lo;
  
  		/* mapping for another database */
  		if (f_dboid != dboid)
--- 3185,3198 ----
  			continue;
  
  		if (sscanf(mapping_de->d_name, LOGICAL_REWRITE_FORMAT,
! 				   &f_dboid, &f_relid, &f_lsn_hi, &f_lsn_lo,
! 				   &f_mapped_xid_hi, &f_mapped_xid_lo,
! 				   &f_create_xid_hi, &f_create_xid_lo) != 8)
  			elog(ERROR, "could not parse filename \"%s\"", mapping_de->d_name);
  
! 		f_lsn = ((uint64) f_lsn_hi) << 32 | f_lsn_lo;
! 		f_mapped_xid = ((uint64) f_mapped_xid_hi) << 32 | f_mapped_xid_lo;
! 		f_create_xid = ((uint64) f_create_xid_hi) << 32 | f_create_xid_lo;
  
  		/* mapping for another database */
  		if (f_dboid != dboid)
*************** UpdateLogicalMappings(HTAB *tuplecid_dat
*** 3227,3233 ****
  	{
  		RewriteMappingFile *f = files_a[off];
  
! 		elog(DEBUG1, "applying mapping: \"%s\" in %u", f->fname,
  			 snapshot->subxip[0]);
  		ApplyLogicalMappingFile(tuplecid_data, relid, f->fname);
  		pfree(f);
--- 3234,3240 ----
  	{
  		RewriteMappingFile *f = files_a[off];
  
! 		elog(DEBUG1, "applying mapping: \"%s\" in " XID_FMT, f->fname,
  			 snapshot->subxip[0]);
  		ApplyLogicalMappingFile(tuplecid_data, relid, f->fname);
  		pfree(f);
diff --git a/src/backend/replication/logical/snapbuild.c b/src/backend/replication/logical/snapbuild.c
new file mode 100644
index e06aa09..91db9de
*** a/src/backend/replication/logical/snapbuild.c
--- b/src/backend/replication/logical/snapbuild.c
*************** SnapBuildDistributeNewCatalogSnapshot(Sn
*** 837,843 ****
  		if (!ReorderBufferXidHasBaseSnapshot(builder->reorder, txn->xid))
  			continue;
  
! 		elog(DEBUG2, "adding a new snapshot to %u at %X/%X",
  			 txn->xid, (uint32) (lsn >> 32), (uint32) lsn);
  
  		/*
--- 837,843 ----
  		if (!ReorderBufferXidHasBaseSnapshot(builder->reorder, txn->xid))
  			continue;
  
! 		elog(DEBUG2, "adding a new snapshot to " XID_FMT " at %X/%X",
  			 txn->xid, (uint32) (lsn >> 32), (uint32) lsn);
  
  		/*
*************** SnapBuildPurgeCommittedTxn(SnapBuild *bu
*** 912,918 ****
  	memcpy(builder->committed.xip, workspace,
  		   surviving_xids * sizeof(TransactionId));
  
! 	elog(DEBUG3, "purged committed transactions from %u to %u, xmin: %u, xmax: %u",
  		 (uint32) builder->committed.xcnt, (uint32) surviving_xids,
  		 builder->xmin, builder->xmax);
  	builder->committed.xcnt = surviving_xids;
--- 912,918 ----
  	memcpy(builder->committed.xip, workspace,
  		   surviving_xids * sizeof(TransactionId));
  
! 	elog(DEBUG3, "purged committed transactions from %u to %u, xmin: " XID_FMT ", xmax: " XID_FMT,
  		 (uint32) builder->committed.xcnt, (uint32) surviving_xids,
  		 builder->xmin, builder->xmax);
  	builder->committed.xcnt = surviving_xids;
*************** SnapBuildCommitTxn(SnapBuild *builder, X
*** 978,984 ****
  			sub_needs_timetravel = true;
  			needs_snapshot = true;
  
! 			elog(DEBUG1, "found subtransaction %u:%u with catalog changes",
  				 xid, subxid);
  
  			SnapBuildAddCommittedTxn(builder, subxid);
--- 978,984 ----
  			sub_needs_timetravel = true;
  			needs_snapshot = true;
  
! 			elog(DEBUG1, "found subtransaction " XID_FMT ":" XID_FMT " with catalog changes",
  				 xid, subxid);
  
  			SnapBuildAddCommittedTxn(builder, subxid);
*************** SnapBuildCommitTxn(SnapBuild *builder, X
*** 1004,1010 ****
  	/* if top-level modified catalog, it'll need a snapshot */
  	if (ReorderBufferXidHasCatalogChanges(builder->reorder, xid))
  	{
! 		elog(DEBUG2, "found top level transaction %u, with catalog changes",
  			 xid);
  		needs_snapshot = true;
  		needs_timetravel = true;
--- 1004,1010 ----
  	/* if top-level modified catalog, it'll need a snapshot */
  	if (ReorderBufferXidHasCatalogChanges(builder->reorder, xid))
  	{
! 		elog(DEBUG2, "found top level transaction " XID_FMT ", with catalog changes",
  			 xid);
  		needs_snapshot = true;
  		needs_timetravel = true;
*************** SnapBuildCommitTxn(SnapBuild *builder, X
*** 1017,1023 ****
  	}
  	else if (needs_timetravel)
  	{
! 		elog(DEBUG2, "forced transaction %u to do timetravel", xid);
  
  		SnapBuildAddCommittedTxn(builder, xid);
  	}
--- 1017,1023 ----
  	}
  	else if (needs_timetravel)
  	{
! 		elog(DEBUG2, "forced transaction " XID_FMT " to do timetravel", xid);
  
  		SnapBuildAddCommittedTxn(builder, xid);
  	}
*************** SnapBuildProcessRunningXacts(SnapBuild *
*** 1126,1132 ****
  	/* Remove transactions we don't need to keep track off anymore */
  	SnapBuildPurgeCommittedTxn(builder);
  
! 	elog(DEBUG3, "xmin: %u, xmax: %u, oldestrunning: %u",
  		 builder->xmin, builder->xmax,
  		 running->oldestRunningXid);
  
--- 1126,1132 ----
  	/* Remove transactions we don't need to keep track off anymore */
  	SnapBuildPurgeCommittedTxn(builder);
  
! 	elog(DEBUG3, "xmin: " XID_FMT ", xmax: " XID_FMT ", oldestrunning: " XID_FMT,
  		 builder->xmin, builder->xmax,
  		 running->oldestRunningXid);
  
*************** SnapBuildFindSnapshot(SnapBuild *builder
*** 1222,1228 ****
  		ereport(DEBUG1,
  				(errmsg_internal("skipping snapshot at %X/%X while building logical decoding snapshot, xmin horizon too low",
  								 (uint32) (lsn >> 32), (uint32) lsn),
! 		errdetail_internal("initial xmin horizon of %u vs the snapshot's %u",
  				 builder->initial_xmin_horizon, running->oldestRunningXid)));
  
  
--- 1222,1228 ----
  		ereport(DEBUG1,
  				(errmsg_internal("skipping snapshot at %X/%X while building logical decoding snapshot, xmin horizon too low",
  								 (uint32) (lsn >> 32), (uint32) lsn),
! 		errdetail_internal("initial xmin horizon of " XID_FMT " vs the snapshot's " XID_FMT,
  				 builder->initial_xmin_horizon, running->oldestRunningXid)));
  
  
*************** SnapBuildFindSnapshot(SnapBuild *builder
*** 1305,1311 ****
  		ereport(LOG,
  			(errmsg("logical decoding found initial starting point at %X/%X",
  					(uint32) (lsn >> 32), (uint32) lsn),
! 			 errdetail("Waiting for transactions (approximately %d) older than %u to end.",
  					   running->xcnt, running->nextXid)));
  
  		SnapBuildWaitSnapshot(running, running->nextXid);
--- 1305,1311 ----
  		ereport(LOG,
  			(errmsg("logical decoding found initial starting point at %X/%X",
  					(uint32) (lsn >> 32), (uint32) lsn),
! 			 errdetail("Waiting for transactions (approximately %d) older than " XID_FMT " to end.",
  					   running->xcnt, running->nextXid)));
  
  		SnapBuildWaitSnapshot(running, running->nextXid);
*************** SnapBuildFindSnapshot(SnapBuild *builder
*** 1329,1335 ****
  		ereport(LOG,
  		  (errmsg("logical decoding found initial consistent point at %X/%X",
  				  (uint32) (lsn >> 32), (uint32) lsn),
! 		   errdetail("Waiting for transactions (approximately %d) older than %u to end.",
  					 running->xcnt, running->nextXid)));
  
  		SnapBuildWaitSnapshot(running, running->nextXid);
--- 1329,1335 ----
  		ereport(LOG,
  		  (errmsg("logical decoding found initial consistent point at %X/%X",
  				  (uint32) (lsn >> 32), (uint32) lsn),
! 		   errdetail("Waiting for transactions (approximately %d) older than " XID_FMT " to end.",
  					 running->xcnt, running->nextXid)));
  
  		SnapBuildWaitSnapshot(running, running->nextXid);
diff --git a/src/backend/replication/walreceiver.c b/src/backend/replication/walreceiver.c
new file mode 100644
index 2723612..c87421c
*** a/src/backend/replication/walreceiver.c
--- b/src/backend/replication/walreceiver.c
*************** static void
*** 1175,1183 ****
  XLogWalRcvSendHSFeedback(bool immed)
  {
  	TimestampTz now;
- 	TransactionId nextXid;
- 	uint32		xmin_epoch,
- 				catalog_xmin_epoch;
  	TransactionId xmin,
  				catalog_xmin;
  	static TimestampTz sendTime = 0;
--- 1175,1180 ----
*************** XLogWalRcvSendHSFeedback(bool immed)
*** 1249,1276 ****
  		catalog_xmin = InvalidTransactionId;
  	}
  
! 	/*
! 	 * Get epoch and adjust if nextXid and oldestXmin are different sides of
! 	 * the epoch boundary.
! 	 */
! 	GetNextXidAndEpoch(&nextXid, &xmin_epoch);
! 	catalog_xmin_epoch = xmin_epoch;
! 	if (nextXid < xmin)
! 		xmin_epoch--;
! 	if (nextXid < catalog_xmin)
! 		catalog_xmin_epoch--;
! 
! 	elog(DEBUG2, "sending hot standby feedback xmin %u epoch %u catalog_xmin %u catalog_xmin_epoch %u",
! 		 xmin, xmin_epoch, catalog_xmin, catalog_xmin_epoch);
  
  	/* Construct the message and send it. */
  	resetStringInfo(&reply_message);
  	pq_sendbyte(&reply_message, 'h');
  	pq_sendint64(&reply_message, GetCurrentTimestamp());
! 	pq_sendint(&reply_message, xmin, 4);
! 	pq_sendint(&reply_message, xmin_epoch, 4);
! 	pq_sendint(&reply_message, catalog_xmin, 4);
! 	pq_sendint(&reply_message, catalog_xmin_epoch, 4);
  	walrcv_send(wrconn, reply_message.data, reply_message.len);
  	if (TransactionIdIsValid(xmin) || TransactionIdIsValid(catalog_xmin))
  		master_has_standby_xmin = true;
--- 1246,1260 ----
  		catalog_xmin = InvalidTransactionId;
  	}
  
! 	elog(DEBUG2, "sending hot standby feedback xmin " XID_FMT " catalog_xmin " XID_FMT,
! 		 xmin, catalog_xmin);
  
  	/* Construct the message and send it. */
  	resetStringInfo(&reply_message);
  	pq_sendbyte(&reply_message, 'h');
  	pq_sendint64(&reply_message, GetCurrentTimestamp());
! 	pq_sendint64(&reply_message, xmin);
! 	pq_sendint64(&reply_message, catalog_xmin);
  	walrcv_send(wrconn, reply_message.data, reply_message.len);
  	if (TransactionIdIsValid(xmin) || TransactionIdIsValid(catalog_xmin))
  		master_has_standby_xmin = true;
diff --git a/src/backend/replication/walsender.c b/src/backend/replication/walsender.c
new file mode 100644
index 976a42f..6c1e348
*** a/src/backend/replication/walsender.c
--- b/src/backend/replication/walsender.c
*************** static void WalSndUpdateProgress(Logical
*** 248,254 ****
  static XLogRecPtr WalSndWaitForWal(XLogRecPtr loc);
  static void LagTrackerWrite(XLogRecPtr lsn, TimestampTz local_flush_time);
  static TimeOffset LagTrackerRead(int head, XLogRecPtr lsn, TimestampTz now);
- static bool TransactionIdInRecentPast(TransactionId xid, uint32 epoch);
  
  static void XLogRead(char *buf, XLogRecPtr startptr, Size count);
  
--- 248,253 ----
*************** PhysicalReplicationSlotNewXmin(Transacti
*** 1860,1909 ****
  }
  
  /*
-  * Check that the provided xmin/epoch are sane, that is, not in the future
-  * and not so far back as to be already wrapped around.
-  *
-  * Epoch of nextXid should be same as standby, or if the counter has
-  * wrapped, then one greater than standby.
-  *
-  * This check doesn't care about whether clog exists for these xids
-  * at all.
-  */
- static bool
- TransactionIdInRecentPast(TransactionId xid, uint32 epoch)
- {
- 	TransactionId nextXid;
- 	uint32		nextEpoch;
- 
- 	GetNextXidAndEpoch(&nextXid, &nextEpoch);
- 
- 	if (xid <= nextXid)
- 	{
- 		if (epoch != nextEpoch)
- 			return false;
- 	}
- 	else
- 	{
- 		if (epoch + 1 != nextEpoch)
- 			return false;
- 	}
- 
- 	if (!TransactionIdPrecedesOrEquals(xid, nextXid))
- 		return false;			/* epoch OK, but it's wrapped around */
- 
- 	return true;
- }
- 
- /*
   * Hot Standby feedback
   */
  static void
  ProcessStandbyHSFeedbackMessage(void)
  {
  	TransactionId feedbackXmin;
- 	uint32		feedbackEpoch;
  	TransactionId feedbackCatalogXmin;
- 	uint32		feedbackCatalogEpoch;
  
  	/*
  	 * Decipher the reply message. The caller already consumed the msgtype
--- 1859,1871 ----
*************** ProcessStandbyHSFeedbackMessage(void)
*** 1911,1926 ****
  	 * of this message.
  	 */
  	(void) pq_getmsgint64(&reply_message);		/* sendTime; not used ATM */
! 	feedbackXmin = pq_getmsgint(&reply_message, 4);
! 	feedbackEpoch = pq_getmsgint(&reply_message, 4);
! 	feedbackCatalogXmin = pq_getmsgint(&reply_message, 4);
! 	feedbackCatalogEpoch = pq_getmsgint(&reply_message, 4);
  
! 	elog(DEBUG2, "hot standby feedback xmin %u epoch %u, catalog_xmin %u epoch %u",
  		 feedbackXmin,
! 		 feedbackEpoch,
! 		 feedbackCatalogXmin,
! 		 feedbackCatalogEpoch);
  
  	/*
  	 * Unset WalSender's xmins if the feedback message values are invalid.
--- 1873,1884 ----
  	 * of this message.
  	 */
  	(void) pq_getmsgint64(&reply_message);		/* sendTime; not used ATM */
! 	feedbackXmin = pq_getmsgint64(&reply_message);
! 	feedbackCatalogXmin = pq_getmsgint64(&reply_message);
  
! 	elog(DEBUG2, "hot standby feedback xmin " XID_FMT " catalog_xmin " XID_FMT,
  		 feedbackXmin,
! 		 feedbackCatalogXmin);
  
  	/*
  	 * Unset WalSender's xmins if the feedback message values are invalid.
*************** ProcessStandbyHSFeedbackMessage(void)
*** 1936,1953 ****
  	}
  
  	/*
- 	 * Check that the provided xmin/epoch are sane, that is, not in the future
- 	 * and not so far back as to be already wrapped around.  Ignore if not.
- 	 */
- 	if (TransactionIdIsNormal(feedbackXmin) &&
- 		!TransactionIdInRecentPast(feedbackXmin, feedbackEpoch))
- 		return;
- 
- 	if (TransactionIdIsNormal(feedbackCatalogXmin) &&
- 		!TransactionIdInRecentPast(feedbackCatalogXmin, feedbackCatalogEpoch))
- 		return;
- 
- 	/*
  	 * Set the WalSender's xmin equal to the standby's requested xmin, so that
  	 * the xmin will be taken into account by GetOldestXmin.  This will hold
  	 * back the removal of dead rows and thereby prevent the generation of
--- 1894,1899 ----
